//=============================================================================
// ANNAAugmentationManager. (C) 2012 "Dei" & Nobody
//=============================================================================
class ANNAAugmentationManager extends CBPAugmentationManager;

/**
  Count the augmentations we have
*/
simulated function int NumAugsOwned()
{
	local Augmentation anAug;
	local int count;

	if (Player == None)
		return 0;

	count = 0;
	anAug = FirstAug;
	while(anAug != None)
	{
		if(anAug.bHasIt)
			count++;

		anAug = anAug.next;
	}

	return count;
}

/**
  Check if the player is allowed to receive an augmentation.
*/
function Augmentation GivePlayerAugmentation(Class<Augmentation> giveClass)
{
    local int CurrentStreak, AllowedAugs, CurrentAugs;

    CurrentStreak = Player.PlayerReplicationInfo.Streak;

    AllowedAugs = DeusExMPGame(Level.Game).InitialAugs+(DeusExMPGame(Level.Game).AugsPerKill*CurrentStreak)+3; // +3 being AugIFF, AugDatalink, AugLight
    CurrentAugs = NumAugsOwned();

    if(CurrentAugs < AllowedAugs || Player.bAdmin == True)
    {
        Super.GivePlayerAugmentation(giveClass);
    }
}

/**
  Should the player be spectating, pretend he has the Radar Transparency augmentation.
*/
simulated function int GetClassLevel(class<Augmentation> augClass)
{
  if(Player != None && Player.PlayerReplicationInfo != None)
    if(Player.PlayerReplicationInfo.bIsSpectator)
      if(augClass == Class'DeusEx.AugRadarTrans')
        return 3;

  return Super.GetClassLevel(augClass);
}

function bool ActivateAugByKey(int keyNum)
{	
  if(Player != None && Player.PlayerReplicationInfo != None)
    if(Player.PlayerReplicationInfo.bIsSpectator)
      return false;

  return Super.ActivateAugByKey(keyNum);
}

function ActivateAll()
{
  if(Player != None && Player.PlayerReplicationInfo != None)
    if(Player.PlayerReplicationInfo.bIsSpectator)
      return;

  Super.ActivateAll();
}

defaultproperties
{
}
