//=============================================================================
// ANNADeathMatch. (C) 2012 "Dei" & Nobody
//=============================================================================
/**
  Gametype for the Deathmatch Game.
*/
class ANNADeathMatch extends MTLDeathMatch;

/** A new structure which extends teh new Scoreboard with informations */
struct PlayerInfo
{
     var int ping;
};

var PlayerInfo PInfo[32]; //Array of the additional structure for 32 players

/** @ignore */
const IDX = 0.14;
/** @ignore */
const PINGX = 0.85;

var ANNAManager Manager;

/**
  Sets the MPL depending on the just loaded map.
*/
event InitGame( string Options, out string Error )
{
    local ANNAManager curManager;
    local bool bFound;
    
    Super.InitGame(Options,Error);

    foreach AllActors(class'ANNAManager', curManager)
      if(curManager != None)
          bFound = true;

    if(!bFound)
      Manager = Spawn(class'ANNAManager');
    else
      Manager = curManager;

    CBPMutator(level.Game.BaseMutator).AddCBPMutator(Spawn(class'ANNAMutator'));
}

/**
  Find and return the ANNAManager
*/
function ANNAManager findManager()
{
  local ANNAManager curManager;
  local bool bFound;

  if(Manager != None)
    return Manager;

  foreach AllActors(class'ANNAManager', curManager)
    if(curManager != None)
      return curManager;

  return none;
}

event PlayerPawn Login (string Portal, string URL, out string Error, Class<PlayerPawn> SpawnClass)
{
 	local MTLPlayer newPlayer;
	local string classStr, purgedClassStr;
	local int pkgLength;
	local Pawn PawnLink;
	local PlayerPawn TestPlayer;

	if((MaxPlayers > 0) && (NumPlayers >= MaxPlayers) )
	{
		Error=TooManyPlayers;
		return None;
	}

	for(PawnLink=Level.PawnList; PawnLink!=None; PawnLink=PawnLink.NextPawn)
	{
		TestPlayer = PlayerPawn(PawnLink);
		if(TestPlayer != None)
    {
      if(Len(TestPlayer.Password) == 0)
      {
        TestPlayer.Password = class'ANNAManager'.static.generateUID();
      }
		}
	}

	SpawnClass=DefaultPlayerClass;
	classStr=ParseOption(URL,"Class");
	pkgLength=InStr(classStr,".");
	if(pkgLength != -1 )
	{
		purgedClassStr = Mid(classStr,pkgLength + 1);
		classStr = Left(classStr,pkgLength);
	}
  else
  {
		purgedClassStr = classStr;
		classStr="";
	}
	if((purgedClassStr ~= "MPNSF") || (purgedClassStr ~= "MTLNSF") )
	  SpawnClass=class'ANNANSF';
    else if((purgedClassStr ~= "MPUNATCO") || (purgedClassStr ~= "MTLUNATCO") )
	  SpawnClass=Class'ANNAUNATCO';
    else if((purgedClassStr ~= "MPMJ12") || (purgedClassStr ~= "MTLMJ12") )
	  SpawnClass=class'ANNAMJ12';

	ChangeOption(URL,"Class",string(SpawnClass));
	newPlayer=MTLPlayer(super(DeathMatchGame).Login(Portal,URL,Error,SpawnClass));
	if(newPlayer != None )
	  newPlayer.V52(newPlayer.PlayerReplicationInfo.PlayerName);

	return newPlayer;
}

exec function ConsoleKick(int playerID)
{
  if(Manager == None)
    Manager = findManager();
  if(Manager == None)
    Manager = Spawn(class'ANNAManager');
    
  Manager.serverKick(playerID);
}

exec function ConsoleKickBan(int playerID)
{
  if(Manager == None)
    Manager = findManager();
  if(Manager == None)
    Manager = Spawn(class'ANNAManager');
    
  Manager.serverBan(playerID);
}

exec function ConsolePlayerList()
{
  if(Manager == None)
    Manager = findManager();
  if(Manager == None)
    Manager = Spawn(class'ANNAManager');
    
  Manager.serverPlayerList();
}

event PostLogin(playerpawn NewPlayer)
{
   local ANNAPlayer DXPlayer;

   Super.PostLogin(NewPlayer);

   DXPlayer = ANNAPlayer(NewPlayer);
   if(DXPlayer != None)
     DXPlayer.CheckInventory();
}

/**
  Disable haxy hax.
*/
function EditActor();

DefaultProperties
{
    GameName="Deathmatch"
    DefaultPlayerClass=class'ANNAJCDenton'
    ScoreboardType=Class'ANNAScoreboard'
}
