//================================================================================
// ANNAHUDObjectSlot. (C) 2012 "Dei" & Nobody
//================================================================================
class ANNAHUDObjectSlot extends CBPHUDObjectSlot;

var bool bActive;
var string itemDescription;
var texture itemIcon;

function UpdateItemText()
{
	local DeusExWeapon weapon;

	itemText = "";

	if(item != None && item.bInObjectBelt)
	{
    bActive = true;
    itemDescription = item.BeltDescription;
    itemIcon = item.Icon;

		if(item.IsA('DeusExWeapon'))
		{
			weapon = DeusExWeapon(item);

			if(weapon.AmmoName != class'AmmoNone' && !weapon.bHandToHand && weapon.ReloadCount != 0 && weapon.AmmoType != None)
				itemText = weapon.AmmoType.beltDescription;

			if(weapon.IsA('WeaponNanoVirusGrenade') || weapon.IsA('WeaponGasGrenade') || weapon.IsA('WeaponEMPGrenade') ||	weapon.IsA('WeaponLAM'))
				if(weapon.AmmoType.AmmoAmount > 1)
					itemText = CountLabel @ weapon.AmmoType.AmmoAmount;
		}
		else if(item.IsA('DeusExPickup') && !item.IsA('NanoKeyRing'))
			if(DeusExPickup(item).NumCopies > 1)
				itemText = DeusExPickup(item).CountLabel @ String(DeusExPickup(item).NumCopies);
	}
  else
  {
    item = None;
    bActive = false;
  }
}

event DrawWindow(GC gc)
{
  if(item == None)
    bActive = false;

  DrawHUDBackground(gc);

  if(fillMode != FM_None)
  {
    SetFillColor();
    gc.SetStyle(DSTY_Translucent);
    gc.SetTileColor(fillColor);
    gc.DrawPattern(slotIconX, slotIconY, slotFillWidth, slotFillHeight, 0, 0, Texture'Solid');
  }

  if(bActive && !bDragging)
  {
    DrawHUDIcon(gc);

    gc.SetAlignments(HALIGN_Center, VALIGN_Center);
    gc.EnableWordWrap(false);
    gc.SetTextColor(colObjectNum);
    gc.DrawText(1, 42, 42, 7, itemDescription);

    if(Len(itemText) > 0)
      gc.DrawText(slotIconX, itemTextPosY, slotFillWidth, 8, itemText);

    if(bButtonPressed)
    {
      gc.SetTileColor(colSelectionBorder);
      gc.SetStyle(DSTY_Masked);
      gc.DrawBorders(slotIconX - 1, slotIconY - 1, borderWidth, borderHeight, 0, 0, 0, 0, texBorders);
    }
  }
  else if(!bActive && Player != None && Player.Level.NetMode != NM_Standalone && Player.bBeltIsMPInventory)
  {
    gc.SetAlignments(HALIGN_Center, VALIGN_Center);
    gc.EnableWordWrap(false);
    gc.SetTextColor(colObjectNum);

    if(objectNum >= 1 && objectNum <= 3)
      gc.DrawText(1, 42, 42, 7, "WEAPONS");
    else if(objectNum >= 4 && objectNum <= 6)
      gc.DrawText(1, 42, 42, 7, "GRENADES");
    else if((objectNum >= 7 && objectNum <= 9) || objectNum == 0)
      gc.DrawText(1, 42, 42, 7, "TOOLS");
  }
  gc.SetAlignments(HALIGN_Right, VALIGN_Center);
  gc.SetTextColor(colObjectNum);
  gc.DrawText(slotNumberX - 1, slotNumberY, 6, 7, objectNum);
}

function DrawHUDIcon(GC GC)
{
	GC.SetStyle(DSTY_Masked);
	GC.SetTileColorRGB(255, 255, 255);

	if(bActive && itemIcon != None)
		GC.DrawTexture(slotIconX, slotIconY, slotFillWidth, slotFillHeight, 0.0, 0.0, itemIcon);
}