//=============================================================================
// ANNATeam. (C) 2012 "Dei" & Nobody
//=============================================================================
/**
  Main Gametype for the Team Deathmatch.
  It includes (resp. inherits) all TDM relevant code which match with ATDM <b>AND</b> BTDM
*/
class ANNATeam extends MTLTeam;
var ANNAManager Manager;

/**
  Sets the MPL depending on the just loaded map.
*/
event InitGame( string Options, out string Error )
{
    local ANNAManager curManager;
    local bool bFound;
    
    Super.InitGame(Options,Error);

    Manager = findManager();
    if(Manager == None)
      Manager = Spawn(class'ANNAManager');

    CBPMutator(level.Game.BaseMutator).AddCBPMutator(Spawn(class'ANNAMutator'));
}

/**
  Find and return the ANNAManager
*/
function ANNAManager findManager()
{
  local ANNAManager curManager;
  local bool bFound;

  if(Manager != None)
    return Manager;

  foreach AllActors(class'ANNAManager', curManager)
    if(curManager != None)
      return curManager;

  return none;
}

/**
  Updates the score array with the latest information about the players.
*/
event PlayerPawn Login (string Portal, string Z56, out string Z57, Class<PlayerPawn> SpawnClass)
{
	local Pawn PawnLink;
	local PlayerPawn TestPlayer;
  
	for(PawnLink=Level.PawnList; PawnLink!=None; PawnLink=PawnLink.NextPawn)
	{
		TestPlayer = PlayerPawn(PawnLink);
		if(TestPlayer != None)
    {
      if(Len(TestPlayer.Password) == 0)
      {
        TestPlayer.Password = class'ANNAManager'.static.generateUID();
      }
		}
	}

  return Super.Login(Portal, Z56, Z57, SpawnClass);
}


exec function ConsoleKick(int playerID)
{
  if(Manager == None)
    Manager = findManager();
  if(Manager == None)
    Manager = Spawn(class'ANNAManager');
    
  Manager.serverKick(playerID);
}

exec function ConsoleKickBan(int playerID)
{
  if(Manager == None)
    Manager = findManager();
  if(Manager == None)
    Manager = Spawn(class'ANNAManager');
    
  Manager.serverBan(playerID);
}

exec function ConsolePlayerList()
{
  if(Manager == None)
    Manager = findManager();
  if(Manager == None)
    Manager = Spawn(class'ANNAManager');
    
  Manager.serverPlayerList();
}

event PostLogin(playerpawn NewPlayer)
{
   local ANNAPlayer DXPlayer;

   Super.PostLogin(NewPlayer);

   DXPlayer = ANNAPlayer(NewPlayer);
   if(DXPlayer != None)
   {
     if(Manager != None && Manager.bResetSkin)
       DXPlayer.CheckSkin();

     DXPlayer.CheckInventory();
   }
}

/**
  Disable haxy hax.
*/
function EditActor();

/**
  When a player restarts, reset their skin?
*/
function bool RestartPlayer( pawn aPlayer )	
{
  if(ANNAPlayer(aPlayer) != None && Manager != None && Manager.bResetSkin)
    ANNAPlayer(aPlayer).CheckSkin();

  return Super.RestartPlayer(aPlayer);
}


DefaultProperties
{
    GameName="Team Deathmatch"
    V1F=class'ANNAUNATCO'
    V1E=Class'ANNANSF'
    DefaultPlayerClass=Class'ANNAUNATCO'
    ScoreboardType=Class'ANNAScoreboard'
}
